LeetCode——987. 二叉树的垂序遍历(Java)
题目描述
题干:
给你二叉树的根结点 root ,请你设计算法计算二叉树的 垂序遍历 序列。
对位于 (row, col) 的每个结点而言,
其左右子结点分别位于 (row + 1, col - 1) 和 (row + 1, col + 1) 。
树的根结点位于 (0, 0) 。
二叉树的 垂序遍历 从最左边的列开始直到最右边的列结束,
按列索引每一列上的所有结点,形成一个按出现位置从上到下排序的有序列表。
如果同行同列上有多个结点,则按结点的值从小到大进行排序。
返回二叉树的 垂序遍历 序列。
示例 1:
输入:root = [3,9,20,null,null,15,7]
输出:[[9],[3,15],[20],[7]]
解释:
列 -1 :只有结点 9 在此列中。
列 0 :只有结点 3 和 15 在此列中,按从上到下顺序。
列 1 :只有结点 20 在此列中。
列 2 :只有结点 7 在此列中。
示例 2:
输入:root = [1,2,3,4,5,6,7]
输出:[[4],[2],[1,5,6],[3],[7]]
解释:
列 -2 :只有结点 4 在此列中。
列 -1 :只有结点 2 在此列中。
列 0 :结点 1 、5 和 6 都在此列中。
1 在上面,所以它出现在前面。
5 和 6 位置都是 (2, 0) ,所以按值从小到大排序,5 在 6 的前面。
列 1 :只有结点 3 在此列中。
列 2 :只有结点 7 在此列中。
示例 3:
输入:root = [1,2,3,4,6,5,7]
输出:[[4],[2],[1,5,6],[3],[7]]
解释:
这个示例实际上与示例 2 完全相同,只是结点 5 和 6 在树中的位置发生了交换。
因为 5 和 6 的位置仍然相同,所以答案保持不变,仍然按值从小到大排序。
题解思路
返回垂序遍历的结果,相对于以前的层序遍历,只不过是换了个方向
层序遍历是按照每行来横向便利,所以我们这次要按照列来纵向便利
因为要统计行、列和节点值,所以哈希表就不太灵活了,我们用数组加链表来代替
正确代码
public List<List<Integer>> verticalTraversal(TreeNode root) {
List<int[]> nodes = new ArrayList<>();
dfs(root, 0, 0, nodes);
// 定义排序方式
// 按照列号优先,之后是行号,最后是值从小到大
Collections.sort(nodes, new Comparator<int[]>() {
@Override
public int compare(int[] o1, int[] o2) {
if (o1[0] != o2[0]) {
return o1[0] - o2[0];
} else if (o1[1] != o2[1]) {
return o1[1] - o2[1];
} else {
return o1[2] - o2[2];
}
}
});
// 按列生成返回链表
List<List<Integer>> ans = new ArrayList<>();
int size = 0;
int lastcol = Integer.MIN_VALUE;
for (int[] node : nodes) {
int col = node[0], row = node[1], value = node[2];
if (col != lastcol) {
lastcol = col;
ans.add(new ArrayList<Integer>());
size++;
}
ans.get(size - 1).add(value);
}
return ans;
}
// 深度优先遍历并并保存每个节点的坐标和值
private void dfs(TreeNode node, int row, int col, List<int[]> nodes) {
if (node == null) {
return;
}
nodes.add(new int[]{col, row, node.val});
dfs(node.left, row + 1, col - 1, nodes);
dfs(node.right, row + 1, col + 1, nodes);
}
总结
记得有道题也是需要保存三个值,但是只有两个值作为比较条件,用的链表搭配哈希表
本题三个值都是同方式的比较,所以需要用数组来作为等价的容器,核心在于比较条件的确立
文章如果存在问题或者有更好的题解,欢迎在评论区斧正和评论,各自努力你我最高处见

浙公网安备 33010602011771号